Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/CoveringOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/CoveringOperator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/CoveringOperator.cs	(revision 9194)
@@ -35,9 +35,9 @@
 
     #region Parameter Properties
-    public ILookupParameter<IItemSet<IClassifier>> ActionsInMatchSetParameter {
-      get { return (ILookupParameter<IItemSet<IClassifier>>)Parameters["ActionsInMatchSet"]; }
+    public ILookupParameter<IItemSet<IAction>> ActionsInMatchSetParameter {
+      get { return (ILookupParameter<IItemSet<IAction>>)Parameters["ActionsInMatchSet"]; }
     }
-    public ILookupParameter<IItemSet<IClassifier>> PossibleActionsParameter {
-      get { return (ILookupParameter<IItemSet<IClassifier>>)Parameters["PossibleActions"]; }
+    public ILookupParameter<IItemSet<IAction>> PossibleActionsParameter {
+      get { return (ILookupParameter<IItemSet<IAction>>)Parameters["PossibleActions"]; }
     }
     public ILookupParameter<IntValue> MinimalNumberOfUniqueActionsParameter {
@@ -77,7 +77,6 @@
     public CoveringOperator()
       : base() {
-      Parameters.Add(new LookupParameter<IClassifier>("CoverClassifier"));
-      Parameters.Add(new LookupParameter<IItemSet<IClassifier>>("ActionsInMatchSet"));
-      Parameters.Add(new LookupParameter<IItemSet<IClassifier>>("PossibleActions"));
+      Parameters.Add(new LookupParameter<IItemSet<IAction>>("ActionsInMatchSet"));
+      Parameters.Add(new LookupParameter<IItemSet<IAction>>("PossibleActions"));
       Parameters.Add(new LookupParameter<IntValue>("MinimalNumberOfUniqueActions"));
       Parameters.Add(new ValueLookupParameter<IOperator>("Evaluator"));
@@ -95,5 +94,5 @@
       bool parallel = ParallelParameter.ActualValue.Value;
 
-      IItemSet<IClassifier> clone = (IItemSet<IClassifier>)PossibleActionsParameter.ActualValue.Clone();
+      IItemSet<IAction> clone = (IItemSet<IAction>)PossibleActionsParameter.ActualValue.Clone();
       clone.ExceptWith(ActionsInMatchSetParameter.ActualValue);
 
@@ -116,7 +115,7 @@
           VariableCreator variableCreator = new VariableCreator();
           int pos = RandomParameter.ActualValue.Next(clone.Count);
-          IClassifier action = clone.ElementAt(pos);
+          IAction action = clone.ElementAt(pos);
           clone.Remove(action);
-          variableCreator.CollectedValues.Add(new ValueParameter<IClassifier>("Action", action));
+          variableCreator.CollectedValues.Add(new ValueParameter<IAction>("Action", action));
           variableCreation.Add(ExecutionContext.CreateOperation(variableCreator, CurrentScope.SubScopes[current + i]));
           creation.Add(ExecutionContext.CreateOperation(creator, CurrentScope.SubScopes[current + i]));
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/DoDeletionBeforeCovering.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/DoDeletionBeforeCovering.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/DoDeletionBeforeCovering.cs	(revision 9194)
@@ -55,4 +55,7 @@
       get { return (IValueLookupParameter<IntValue>)Parameters["NumberToDelete"]; }
     }
+    public ILookupParameter<IClassifierComparer> ClassifierComparerParameter {
+      get { return (ILookupParameter<IClassifierComparer>)Parameters["ClassifierComparer"]; }
+    }
     #endregion
 
@@ -71,4 +74,5 @@
       Parameters.Add(new ValueLookupParameter<BoolValue>("DoDeletion"));
       Parameters.Add(new ValueLookupParameter<IntValue>("NumberToDelete"));
+      Parameters.Add(new LookupParameter<IClassifierComparer>("ClassifierComparer"));
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -77,5 +81,5 @@
 
     public override IOperation Apply() {
-      IItemSet<IClassifier> uniqueActions = new ItemSet<IClassifier>();
+      IItemSet<IAction> uniqueActions = new ItemSet<IAction>(ClassifierComparerParameter.ActualValue);
       var classifiers = ClassifiersParameter.ActualValue;
       var matchcondition = MatchConditionParameter.ActualValue;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICovering.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICovering.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICovering.cs	(revision 9194)
@@ -26,6 +26,6 @@
 namespace HeuristicLab.Encodings.ConditionActionEncoding {
   public interface ICovering : IStochasticOperator {
-    ILookupParameter<IItemSet<IClassifier>> ActionsInMatchSetParameter { get; }
-    ILookupParameter<IItemSet<IClassifier>> PossibleActionsParameter { get; }
+    ILookupParameter<IItemSet<IAction>> ActionsInMatchSetParameter { get; }
+    ILookupParameter<IItemSet<IAction>> PossibleActionsParameter { get; }
 
     ILookupParameter<IntValue> MinimalNumberOfUniqueActionsParameter { get; }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICoveringSolutionCreator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICoveringSolutionCreator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Covering/ICoveringSolutionCreator.cs	(revision 9194)
@@ -28,6 +28,6 @@
 namespace HeuristicLab.Encodings.ConditionActionEncoding {
   public interface ICoveringSolutionCreator : IOperator, IParameterizedNamedItem, INamedItem, IParameterizedItem, IItem, IContent, IDeepCloneable, ICloneable, IStochasticOperator {
-    ILookupParameter<IClassifier> CoverClassifierParameter { get; }
-    ILookupParameter<IClassifier> ActionParameter { get; }
+    ILookupParameter<IInput> CoverInputParameter { get; }
+    ILookupParameter<IAction> ActionParameter { get; }
 
     IValueLookupParameter<IClassifier> CreatedClassifierParameter { get; }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/GA/InsertInPopulationOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/GA/InsertInPopulationOperator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/GA/InsertInPopulationOperator.cs	(revision 9194)
@@ -86,5 +86,5 @@
         IClassifier cl = classifiers[indices];
         for (int i = 0; i < classifiers.Length; i++) {
-          if (!hasToBeDeleted[i].Value && !insertInPopulation[i].Value && cl.Equals(classifiers[i])) {
+          if (!hasToBeDeleted[i].Value && !insertInPopulation[i].Value && cl.Identical(classifiers[i])) {
             numerosities[i].Value += numerosities[indices].Value;
             hasToBeDeleted[indices].Value = true;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj	(revision 9194)
@@ -43,7 +43,4 @@
     </Reference>
     <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <Private>False</Private>
-    </Reference>
-    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <Private>False</Private>
     </Reference>
@@ -124,6 +121,4 @@
     <Compile Include="Reinforcement\IActionExecuter.cs" />
     <Compile Include="Reinforcement\IClassifierFetcher.cs" />
-    <Compile Include="Selectors\IMatchSelector.cs" />
-    <Compile Include="Selectors\MatchSelector.cs" />
     <Compile Include="Selectors\PreservingRightReducer.cs" />
     <Compile Include="Subsumption\ActionSetSubsumptionOperator.cs" />
@@ -140,5 +135,10 @@
     <None Include="Plugin.cs.frame" />
   </ItemGroup>
-  <ItemGroup />
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
+      <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
+      <Name>HeuristicLab.Core-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/IClassifier.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/IClassifier.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/IClassifier.cs	(revision 9194)
@@ -20,25 +20,30 @@
 #endregion
 
-using System;
+using System.Collections.Generic;
 using HeuristicLab.Core;
 
 namespace HeuristicLab.Encodings.ConditionActionEncoding {
-  /// <summary>
-  /// IMatching is used in dictinoaries, therefore the methods "Equals" and "GetHashCode" have to be overriden
-  /// IEquatable<IMatching> should be implemented as well.
-  /// 
-  /// This also helps to implement macroclassifiers later on
-  /// </summary>
-  public interface IClassifier : IItem, IEquatable<IClassifier> {
-    IClassifier Condition { get; }
-    IClassifier Action { get; }
-    bool MatchCondition(IClassifier target);
-    bool MatchAction(IClassifier target);
+  public interface IClassifier : IItem {
+    ICondition Condition { get; }
+    IAction Action { get; }
+
+    bool MatchInput(IInput target);
+    bool MatchAction(IAction target);
     bool IsMoreGeneral(IClassifier target);
+    bool IsMoreGeneral(ICondition target);
 
-    //to use IMatching as key in a dictionary, Equals and GetHashCode have to be override. 
-    //Also IEquatable<Class> should be implemented.
-    bool Equals(object obj);
-    int GetHashCode();
+    bool Identical(IClassifier target);
   }
+
+  public interface ICondition : IItem {
+    bool Match(IInput target);
+  }
+
+  public interface IAction : IItem {
+    bool Match(IAction target);
+  }
+
+  public interface IInput : IItem { }
+
+  public interface IClassifierComparer : IEqualityComparer<IAction>, IItem { }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionModel.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionModel.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionModel.cs	(revision 9194)
@@ -28,6 +28,6 @@
 
     int ClassifierCount { get; }
-    IEnumerable<IClassifier> GetAction(IEnumerable<IClassifier> classifiers);
-    IClassifier GetAction(IClassifier classifier);
+    IEnumerable<IAction> GetAction(IEnumerable<IInput> classifiers);
+    IAction GetAction(IInput classifier);
   }
 }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblem.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblem.cs	(revision 9194)
@@ -37,4 +37,6 @@
     //IItemSet<IClassifier> PossibleActions { get; }
 
+    IParameter ClassifierComparerParameter { get; }
+
     ICoveringSolutionCreator CoveringSolutionCreator { get; }
     IParameter CoveringSolutionCreatorParameter { get; }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblemData.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblemData.cs	(revision 9194)
@@ -43,6 +43,9 @@
     bool IsTestSample(int index);
 
-    IEnumerable<IClassifier> FetchClassifier(IEnumerable<int> rows);
-    IClassifier FetchClassifier(int rowNumber);
+    IEnumerable<IInput> FetchInput(IEnumerable<int> rows);
+    IInput FetchInput(int rowNumber);
+
+    IEnumerable<IAction> FetchAction(IEnumerable<int> rows);
+    IAction FetchAction(int rowNumber);
 
     event EventHandler Changed;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/CountNumberOfUniqueActions.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/CountNumberOfUniqueActions.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/CountNumberOfUniqueActions.cs	(revision 9194)
@@ -35,6 +35,9 @@
       get { return (ILookupParameter<ItemArray<IClassifier>>)Parameters["Classifiers"]; }
     }
-    public IValueLookupParameter<IItemSet<IClassifier>> UniqueActionsParameter {
-      get { return (IValueLookupParameter<IItemSet<IClassifier>>)Parameters["UniqueActions"]; }
+    public ILookupParameter<IClassifierComparer> ClassifierComparerParameter {
+      get { return (ILookupParameter<IClassifierComparer>)Parameters["ClassifierComparer"]; }
+    }
+    public IValueLookupParameter<IItemSet<IAction>> UniqueActionsParameter {
+      get { return (IValueLookupParameter<IItemSet<IAction>>)Parameters["UniqueActions"]; }
     }
     public IValueLookupParameter<IntValue> NumberOfUniqueActionsParameter {
@@ -53,10 +56,11 @@
       : base() {
       Parameters.Add(new ScopeTreeLookupParameter<IClassifier>("Classifiers"));
-      Parameters.Add(new ValueLookupParameter<IItemSet<IClassifier>>("UniqueActions"));
+      Parameters.Add(new LookupParameter<IClassifierComparer>("ClassifierComparer"));
+      Parameters.Add(new ValueLookupParameter<IItemSet<IAction>>("UniqueActions"));
       Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfUniqueActions"));
     }
 
     public override IOperation Apply() {
-      ItemSet<IClassifier> actions = new ItemSet<IClassifier>();
+      ItemSet<IAction> actions = new ItemSet<IAction>(ClassifierComparerParameter.ActualValue);
       foreach (var classifier in ClassifiersParameter.ActualValue) {
         actions.Add(classifier.Action);
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchActionOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchActionOperator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchActionOperator.cs	(revision 9194)
@@ -34,6 +34,6 @@
       get { return (ILookupParameter<BoolValue>)Parameters["MatchAction"]; }
     }
-    public ILookupParameter<IClassifier> TargetMatchParameter {
-      get { return (ILookupParameter<IClassifier>)Parameters["TargetMatchParameter"]; }
+    public ILookupParameter<IAction> TargetMatchParameter {
+      get { return (ILookupParameter<IAction>)Parameters["TargetMatchParameter"]; }
     }
     public ILookupParameter<IClassifier> MatchParameter {
@@ -49,5 +49,5 @@
       : base() {
       Parameters.Add(new LookupParameter<BoolValue>("MatchAction", "True if the action matches."));
-      Parameters.Add(new ValueLookupParameter<IClassifier>("TargetMatchParameter", "Target that has to be matched by the match parameter."));
+      Parameters.Add(new ValueLookupParameter<IAction>("TargetMatchParameter", "Target that has to be matched by the match parameter."));
       Parameters.Add(new ValueLookupParameter<IClassifier>("MatchParameter", "The matching encoding contained in each sub-scope which is used for selection."));
     }
@@ -57,5 +57,5 @@
 
     public override IOperation Apply() {
-      IClassifier target = TargetMatchParameter.ActualValue;
+      IAction target = TargetMatchParameter.ActualValue;
       IClassifier match = MatchParameter.ActualValue;
       MatchActionParameter.ActualValue = new BoolValue(match.MatchAction(target));
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchConditionOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchConditionOperator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/MatchConditionOperator.cs	(revision 9194)
@@ -34,6 +34,6 @@
       get { return (ILookupParameter<BoolValue>)Parameters["MatchCondition"]; }
     }
-    public ILookupParameter<IClassifier> TargetMatchParameter {
-      get { return (ILookupParameter<IClassifier>)Parameters["TargetMatchParameter"]; }
+    public ILookupParameter<IInput> TargetMatchParameter {
+      get { return (ILookupParameter<IInput>)Parameters["TargetMatchParameter"]; }
     }
     public ILookupParameter<IClassifier> MatchParameter {
@@ -49,5 +49,5 @@
       : base() {
       Parameters.Add(new LookupParameter<BoolValue>("MatchCondition", "True if the condition matches."));
-      Parameters.Add(new ValueLookupParameter<IClassifier>("TargetMatchParameter", "Target that has to be matched by the match parameter."));
+      Parameters.Add(new ValueLookupParameter<IInput>("TargetMatchParameter", "Target that has to be matched by the match parameter."));
       Parameters.Add(new ValueLookupParameter<IClassifier>("MatchParameter", "The matching encoding contained in each sub-scope which is used for selection."));
     }
@@ -57,7 +57,7 @@
 
     public override IOperation Apply() {
-      IClassifier target = TargetMatchParameter.ActualValue;
+      IInput target = TargetMatchParameter.ActualValue;
       IClassifier match = MatchParameter.ActualValue;
-      MatchConditionParameter.ActualValue = new BoolValue(match.MatchCondition(target));
+      MatchConditionParameter.ActualValue = new BoolValue(match.MatchInput(target));
       return base.Apply();
     }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/PredictionArrayCalculator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/PredictionArrayCalculator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/PredictionArrayCalculator.cs	(revision 9194)
@@ -33,4 +33,7 @@
   public class PredictionArrayCalculator : SingleSuccessorOperator {
 
+    public ILookupParameter<IClassifierComparer> ClassifierComparerParameter {
+      get { return (ILookupParameter<IClassifierComparer>)Parameters["ClassifierComparer"]; }
+    }
     public ILookupParameter<ItemArray<DoubleValue>> FitnessParameter {
       get { return (ILookupParameter<ItemArray<DoubleValue>>)Parameters["Fitness"]; }
@@ -39,6 +42,6 @@
       get { return (ILookupParameter<ItemArray<DoubleValue>>)Parameters["Prediction"]; }
     }
-    public IValueParameter<IItemDictionary<IClassifier, DoubleValue>> PredictionArrayParameter {
-      get { return (IValueParameter<IItemDictionary<IClassifier, DoubleValue>>)Parameters["PredictionArray"]; }
+    public IValueParameter<IItemDictionary<IAction, DoubleValue>> PredictionArrayParameter {
+      get { return (IValueParameter<IItemDictionary<IAction, DoubleValue>>)Parameters["PredictionArray"]; }
     }
     public ILookupParameter<ItemArray<IClassifier>> MatchParameter {
@@ -53,7 +56,8 @@
     public PredictionArrayCalculator()
       : base() {
+      Parameters.Add(new LookupParameter<IClassifierComparer>("ClassifierComparer"));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Fitness"));
       Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Prediction"));
-      Parameters.Add(new ValueLookupParameter<IItemDictionary<IClassifier, DoubleValue>>("PredictionArray"));
+      Parameters.Add(new ValueLookupParameter<IItemDictionary<IAction, DoubleValue>>("PredictionArray"));
       Parameters.Add(new ScopeParameter("CurrentScope", "The current scope from which sub-scopes should be selected."));
       Parameters.Add(new ScopeTreeLookupParameter<IClassifier>("MatchParameter", "The matching encoding contained in each sub-scope which is used for selection."));
@@ -64,6 +68,6 @@
 
     public sealed override IOperation Apply() {
-      IItemDictionary<IClassifier, DoubleValue> predictionArray = new ItemDictionary<IClassifier, DoubleValue>();
-      IDictionary<IClassifier, double> fitnessSumPerAction = new Dictionary<IClassifier, double>();
+      IItemDictionary<IAction, DoubleValue> predictionArray = new ItemDictionary<IAction, DoubleValue>(ClassifierComparerParameter.ActualValue);
+      IDictionary<IAction, double> fitnessSumPerAction = new Dictionary<IAction, double>(ClassifierComparerParameter.ActualValue);
       ItemArray<DoubleValue> fitnesses = FitnessParameter.ActualValue;
       ItemArray<DoubleValue> predictions = PredictionParameter.ActualValue;
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/ActionExecuter.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/ActionExecuter.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/ActionExecuter.cs	(revision 9194)
@@ -33,9 +33,9 @@
 
     #region parameter
-    public IValueLookupParameter<IClassifier> SelectedActionParameter {
-      get { return (IValueLookupParameter<IClassifier>)Parameters["SelectedAction"]; }
+    public IValueLookupParameter<IAction> SelectedActionParameter {
+      get { return (IValueLookupParameter<IAction>)Parameters["SelectedAction"]; }
     }
-    public IValueLookupParameter<IClassifier> CurrentClassifierToMatchParameter {
-      get { return (IValueLookupParameter<IClassifier>)Parameters["CurrentClassifierToMatch"]; }
+    public IValueLookupParameter<IAction> CurrentActionToMatchParameter {
+      get { return (IValueLookupParameter<IAction>)Parameters["CurrentActionToMatch"]; }
     }
     public IValueLookupParameter<DoubleValue> CurrentPayoffParameter {
@@ -61,6 +61,6 @@
     public ActionExecuter()
       : base() {
-      Parameters.Add(new ValueLookupParameter<IClassifier>("SelectedAction"));
-      Parameters.Add(new ValueLookupParameter<IClassifier>("CurrentClassifierToMatch"));
+      Parameters.Add(new ValueLookupParameter<IAction>("SelectedAction"));
+      Parameters.Add(new ValueLookupParameter<IAction>("CurrentActionToMatch"));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("CurrentPayoff"));
       Parameters.Add(new ValueLookupParameter<DoubleValue>("NegativeReward"));
@@ -69,5 +69,5 @@
 
     public override IOperation Apply() {
-      if (SelectedActionParameter.ActualValue.MatchAction(CurrentClassifierToMatchParameter.ActualValue)) {
+      if (SelectedActionParameter.ActualValue.Match(CurrentActionToMatchParameter.ActualValue)) {
         CurrentPayoffParameter.ActualValue = PositiveRewardParameter.ActualValue;
       } else {
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/ClassifierFetcher.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/ClassifierFetcher.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/ClassifierFetcher.cs	(revision 9194)
@@ -33,7 +33,11 @@
   [StorableClass]
   public class ClassifierFetcher : SingleSuccessorOperator, IClassifierFetcher {
+
     #region parameters
-    public IValueLookupParameter<IClassifier> CurrentClassifierToMatchParameter {
-      get { return (IValueLookupParameter<IClassifier>)Parameters["CurrentClassifierToMatch"]; }
+    public IValueLookupParameter<IInput> CurrentInputToMatchParameter {
+      get { return (IValueLookupParameter<IInput>)Parameters["CurrentConditionToMatch"]; }
+    }
+    public IValueLookupParameter<IAction> CurrentActionToMatchParameter {
+      get { return (IValueLookupParameter<IAction>)Parameters["CurrentActionToMatch"]; }
     }
     public ILookupParameter<IConditionActionProblemData> ProblemDataParameter {
@@ -56,5 +60,6 @@
     public ClassifierFetcher()
       : base() {
-      Parameters.Add(new ValueLookupParameter<IClassifier>("CurrentClassifierToMatch"));
+      Parameters.Add(new ValueLookupParameter<IInput>("CurrentConditionToMatch"));
+      Parameters.Add(new ValueLookupParameter<IAction>("CurrentActionToMatch"));
       Parameters.Add(new LookupParameter<IConditionActionProblemData>("ProblemData"));
       Parameters.Add(new LookupParameter<IntValue>("Iteration"));
@@ -68,5 +73,6 @@
       var trainingIndices = ProblemData.TrainingIndices.ToList();
       int index = IterationParameter.ActualValue.Value % trainingIndices.Count;
-      CurrentClassifierToMatchParameter.ActualValue = ProblemDataParameter.ActualValue.FetchClassifier(trainingIndices[index]);
+      CurrentInputToMatchParameter.ActualValue = ProblemDataParameter.ActualValue.FetchInput(trainingIndices[index]);
+      CurrentActionToMatchParameter.ActualValue = ProblemDataParameter.ActualValue.FetchAction(trainingIndices[index]);
       return base.Apply();
     }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IActionExecuter.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IActionExecuter.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IActionExecuter.cs	(revision 9194)
@@ -27,6 +27,6 @@
 namespace HeuristicLab.Encodings.ConditionActionEncoding {
   public interface IActionExecuter : IOperator, IParameterizedNamedItem, INamedItem, IParameterizedItem, IItem, IContent, IDeepCloneable, ICloneable {
-    IValueLookupParameter<IClassifier> SelectedActionParameter { get; }
-    IValueLookupParameter<IClassifier> CurrentClassifierToMatchParameter { get; }
+    IValueLookupParameter<IAction> SelectedActionParameter { get; }
+    IValueLookupParameter<IAction> CurrentActionToMatchParameter { get; }
     IValueLookupParameter<DoubleValue> CurrentPayoffParameter { get; }
     ILookupParameter<DoubleValue> NegativeRewardParameter { get; }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IClassifierFetcher.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IClassifierFetcher.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Reinforcement/IClassifierFetcher.cs	(revision 9194)
@@ -27,5 +27,6 @@
 namespace HeuristicLab.Encodings.ConditionActionEncoding {
   public interface IClassifierFetcher : IOperator, IParameterizedNamedItem, INamedItem, IParameterizedItem, IItem, IContent, IDeepCloneable, ICloneable {
-    IValueLookupParameter<IClassifier> CurrentClassifierToMatchParameter { get; }
+    IValueLookupParameter<IInput> CurrentInputToMatchParameter { get; }
+    IValueLookupParameter<IAction> CurrentActionToMatchParameter { get; }
     ILookupParameter<IConditionActionProblemData> ProblemDataParameter { get; }
     ILookupParameter<IntValue> IterationParameter { get; }
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Subsumption/CheckGASubsumptionOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Subsumption/CheckGASubsumptionOperator.cs	(revision 9193)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Subsumption/CheckGASubsumptionOperator.cs	(revision 9194)
@@ -105,5 +105,5 @@
       for (int i = 0; i < parents.Length; i++) {
         IClassifier curParent = parents[i];
-        if (curParent.MatchAction(child)) {
+        if (curParent.MatchAction(child.Action)) {
           if (CouldSubsume(experiences[i], errors[i])) {
             if (curParent.IsMoreGeneral(child)) {
